"use strict";
var Renderer = (function () {
    function Renderer(notifier, rootElementId) {
        this.notifier = notifier;
        this.rootElementId = rootElementId;
        notifier.subscribe(this);
    }
    Renderer.prototype.getRootDiv = function () {
        var rootDiv = document.getElementById(this.rootElementId);
        if (!rootDiv) {
            rootDiv = document.createElement("div");
            rootDiv.id = this.rootElementId;
            document.body.appendChild(rootDiv);
        }
        return rootDiv;
    };
    Renderer.prototype.onStateChanged = function () {
        this.render();
    };
    return Renderer;
}());
exports.Renderer = Renderer;
