"use strict";
var Cloner = (function () {
    function Cloner() {
    }
    Cloner.prototype.mixin = function (dest, source, copyFunc) {
        var propName;
        var propValue;
        var empty = {};
        for (propName in source) {
            propValue = source[propName];
            if (!(propName in dest) || (dest[propName] !== propValue && (!(propName in empty) || empty[propName] !== propValue))) {
                dest[propName] = copyFunc ? copyFunc.call(this, propValue) : propValue;
            }
        }
        return dest;
    };
    Cloner.prototype.clone = function (source) {
        if (!source || typeof source != "object" || Object.prototype.toString.call(source) === "[object Function]") {
            return source;
        }
        if (source.nodeType && "cloneNode" in source) {
            return source.cloneNode(true);
        }
        if (source instanceof Date) {
            return new Date(source.getTime());
        }
        if (source instanceof RegExp) {
            return new RegExp(source);
        }
        if (source instanceof Array) {
            var arrayCopy = new Array();
            for (var i = 0, l = source.length; i < l; ++i) {
                if (i in source) {
                    arrayCopy.push(this.clone(source[i]));
                }
            }
            return arrayCopy;
        }
        else {
            var objectCopy = source.constructor ? new source.constructor() : {};
            return this.mixin(objectCopy, source, this.clone);
        }
    };
    return Cloner;
}());
exports.Cloner = Cloner;
