/// <reference path="../externals/es6-promise.d.ts" />
export interface IState {
}
export interface IAction {
    execute(state: IState): IState;
}
export interface IAsyncAction {
    execute(state: IState, resolve: (value?: IState) => void, reject: (errors?: any) => void): void;
}
export interface ICloner {
    clone(source: any): any;
}
export interface IStore {
    dispatch(action: IAction): IState;
    dispatchAsync(action: IAsyncAction): Promise<IState>;
    getState<TState extends IState>(): TState;
}
